import * as React from 'react';
interface ComponentProps {
    /** The title of the announcement. */
    title: string;
    /** The general card text on the announcement. */
    subtitle: string;
    /**
     * The image source string used on the left side of the image.
     * Use a square image for the best results.
     * Dimensions are 68x68 pixels.
     */
    imageSource: string;
    /** The link used when the announcement is clicked. */
    link: string;
    /**
     * An optional property specifying the number of days
     * the cookie will live before the announcement is
     * shown again to a user.
     */
    daysToLive?: number;
    /**
     * The number of seconds a user has to
     * keep the page open before the
     * announcement is shown.
     */
    secondsBeforeBannerShows?: number;
    /**
     * Change the size of the close icon shown
     * in the top right corner of the announcement.
     */
    closeIconSize?: number;
}
declare const Announcement: React.FunctionComponent<ComponentProps>;
export default Announcement;
